exercise_05_22: main.o | .gitignore
	g++ $^ -o $@ 

main.ii: main.cpp
	g++ -E $^ -o $@

main.s: main.ii
	g++ -S $^ -o $@

main.o: main.s
	g++ -c $^ -o $@
.gitignore:
	echo "exercise_05_22" > $@

clean:
	rm *.ii *.s *.o *.out exercise_05_22 .gitignore

test: exercise_05_22
	@./exercise_05_22 < test.in > test.out
	@diff test.out test.expected > /dev/null 2>&1 && echo PASSED || echo FAILED

.PRECIOUS: main.ii main.s
.SECONDARY: main.ii main.s

